﻿window.onload = function () {
	select = document.getElementById("fotoalbum");
	obrazky = document.getElementById("photos");
	bw = document.getElementById("bigview");
	loadAlbums()
	window.onresize();

	bw.querySelector(".prev").onclick = prev;
	bw.querySelector(".next").onclick = next;
}

var select;
var obrazky;
var bw;

function loadAlbums() {
	var ajax = new XMLHttpRequest()
	ajax.open("GET", "http://192.168.2.222/api/json/index")
	ajax.onreadystatechange = function () {
		if (ajax.readyState == 4 && ajax.status == 200) {
			select.innerHTML = ""
			var json = JSON.parse(ajax.response);
			for (var i = 0; i < json.length; i++) {
				var option = document.createElement("option");
				option.value = json[i].id;
				option.textContent = json[i].name;
				select.appendChild(option);
				if (i == 0) {
					openAlbum(json[i].id)
				}
			}
			select.onselect = select.onchange = function () {
				openAlbum(select.value);
			}
		}
	}
	ajax.send(null);

}

function openAlbum(id) {
	var ajax = new XMLHttpRequest()
	ajax.open("GET", "http://192.168.2.222/api/json/" + id);
	ajax.onreadystatechange = function () {
		if (ajax.readyState == 4 && ajax.status == 200) {
			obrazky.innerHTML = "";
			var json = JSON.parse(ajax.response);
			for (var i = 0; i < json.length; i++) {
				var img = document.createElement("img")
				img.src = json[i].url;
				img.alt = json[i].description;
				img.onclick = popup;
				obrazky.appendChild(img);
			}
		}
	}
	ajax.send(null);
	setLabel(id)
}

function setLabel(id) {
	for (var i = 0; i < select.children.length; i++) {
		if (select.children[i].value == id) {
			document.querySelector("#album-label").textContent = select.children[i].textContent;
		}
	}
}

function popup() {
	var img = bw.querySelector("img");

	var lbls = document.querySelectorAll(".photo-label");
	for (var i = 0; i < lbls.length; i++) {
		lbls[i].classList.remove("photo-label");
	}

	var lbl = document.createElement("p");
	lbl.classList.add("photo-label");
	lbl.textContent = this.alt;
	if (this.alt != "undefined") {
		document.body.appendChild(lbl);
	}
	img.src = this.src;
	bw.style.display = "block";
	window.onresize();
}

window.onresize = function () {
	bw.style.height = window.innerHeight - 60 + "px"
	bw.style.width = window.innerWidth - 40 + "px"

	var img = bw.querySelector("img");
	
	img.style.height = (window.innerHeight - 60) * 0.9 + "px";
	img.style.top = (window.innerHeight - 60) * 0.05 + "px";
	var par = img.parentNode;
	document.body.appendChild(img);
	img.style.display = "block";
	img.style.marginLeft = ((window.innerWidth / 2) - img.clientWidth / 2) + "px"
	document.body.removeChild(img);
	par.appendChild(img);

	var prev = bw.querySelector(".prev")
	prev.style.left = ((window.innerWidth / 2) - img.clientWidth / 2) + "px"
	var next = bw.querySelector(".next")
	next.style.left = ((window.innerWidth / 2) + img.clientWidth / 2 - next.clientWidth) + "px"

}

window.onkeydown = function (e) {
	if (e.keyCode == 27) {
		bw.style.display = "none";
	} else if (e.keyCode == 37) { // <
		prev();
	} else if (e.keyCode == 39) { // >
		next();
	} else if (e.keyCode == 70) { // f
		var elem = document.querySelector(":root");
		if (elem.requestFullscreen) {
			elem.requestFullscreen();
		} else if (elem.msRequestFullscreen) {
			elem.msRequestFullscreen();
		} else if (elem.mozRequestFullScreen) {
			elem.mozRequestFullScreen();
		} else if (elem.webkitRequestFullscreen) {
			elem.webkitRequestFullscreen();
		}
	}
}

function prev() {
	var img = bw.querySelector("img");
	var preve = document.querySelector("#photos > img[src='" + img.src + "']").previousElementSibling;
	if (preve) {
		popup.call(preve)
	}
}

function next() {
	var img = bw.querySelector("img");
	var nexte = document.querySelector("#photos > img[src='" + img.src + "']").nextElementSibling;
	if (nexte) {
		popup.call(nexte)
	}
}